--
-- InteractiveControlPanel
-- Specialization for InteractiveControlPanel
--
-- @author:  	Manuel Leithner
-- @date:		20/10/10
-- @version:	v2.0
-- @history:	v1.0 - initial implementation
--				v2.0 - Converted to LS2011
--

InteractiveControlPanel = {};

function InteractiveControlPanel.prerequisitesPresent(specializations)
	return true;

end;

function InteractiveControlPanel:load(xmlFile)

	
	self.detachPosition = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.controlPanel#detachPosition"));
	self.controlPanel = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.controlPanel#index"));
    self.attacherVehicleCopy = nil;
	
	self.Luce1 = {};
	self.Luce1.index =  Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Luce1#index"));
	self.Luce1.attiva = false;
	
	self.Luce2 = {};
	self.Luce2.index =  Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Luce2#index"));
	self.Luce2.attiva = false;
	
	self.Luce3 = {};
	self.Luce3.index =  Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Luce3#index"));
	self.Luce3.attiva = false;
	
end;

function InteractiveControlPanel:delete()
end;

function InteractiveControlPanel:mouseEvent(posX, posY, isDown, isUp, button)
end;

function InteractiveControlPanel:keyEvent(unicode, sym, modifier, isDown)
end;

function InteractiveControlPanel:update(dt)	
 if self:getIsActive() then
 self.Luce3.attiva = true;
 local hasGroundContact = self.cultivatorHasGroundContact;
 
 if  hasGroundContact then
 self.Luce1.attiva = false;
 self.Luce2.attiva = true;
 else
 self.Luce1.attiva = true;
 self.Luce2.attiva = false;
 end

 if getVisibility(self.Luce1.index) ~= self.Luce1.attiva then
				setVisibility(self.Luce1.index, self.Luce1.attiva);
			end;
  if getVisibility(self.Luce2.index) ~= self.Luce2.attiva then
				setVisibility(self.Luce2.index, self.Luce2.attiva);
			end;
  if getVisibility(self.Luce3.index) ~= self.Luce3.attiva then
				setVisibility(self.Luce3.index, self.Luce3.attiva);
			end;

  end;
end;

function InteractiveControlPanel:updateTick(dt)
    
end;
       

function InteractiveControlPanel:draw()
end;

function InteractiveControlPanel:onAttach(attacherVehicle)
	self.attacherVehicleCopy = attacherVehicle;
	if attacherVehicle.addControlPanel ~= nil then
		local wasSuccessful = attacherVehicle:addControlPanel(self);
	end;	
end;

function InteractiveControlPanel:onDetach()
	if self.attacherVehicleCopy.removeControlPanel ~= nil then
		local wasSuccessful = self.attacherVehicleCopy:removeControlPanel(self);
	end;

	self.attacherVehicleCopy = nil;
	
	 if getVisibility(self.Luce1.index) == true then
				setVisibility(self.Luce1.index, false);
			end;
  if getVisibility(self.Luce2.index) == true then
				setVisibility(self.Luce2.index, false);
			end;
  if getVisibility(self.Luce3.index) == true then
				setVisibility(self.Luce3.index, false);
			end;
	
end